# Generated by Django 4.2.2 on 2023-06-16 11:21

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import zut.json


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Tracking_EntityType',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('app_label', models.CharField(max_length=1000)),
                ('model_name', models.CharField(max_length=1000)),
                ('created', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'unique_together': {('app_label', 'model_name')},
            },
        ),
        migrations.CreateModel(
            name='Tracking_Origin',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('address', models.CharField(blank=True, max_length=250)),
                ('endpoint', models.CharField(max_length=250)),
                ('auth', models.CharField(blank=True, max_length=250)),
                ('details', models.CharField(blank=True, max_length=250)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.RESTRICT, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Tracking_History',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('entity_id', models.BigIntegerField()),
                ('data', models.JSONField(decoder=zut.json.ExtendedJSONDecoder, encoder=zut.json.ExtendedJSONEncoder, help_text='Modified data')),
                ('data_saved', models.DateTimeField(help_text='Date of last save of historized data')),
                ('created', models.DateTimeField(auto_now_add=True, help_text='Date of insertion of history entry')),
                ('entity_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='zut.tracking_entitytype')),
                ('origin', models.ForeignKey(blank=True, help_text='Origin of insertion of history entry', null=True, on_delete=django.db.models.deletion.RESTRICT, related_name='+', to='zut.tracking_origin')),
            ],
            options={
                'ordering': ['created'],
            },
        ),
        migrations.AddConstraint(
            model_name='tracking_origin',
            constraint=models.UniqueConstraint(fields=('user', 'address', 'endpoint', 'auth', 'details'), name='zut_tracking_origin_uniq'),
        ),
        migrations.AddConstraint(
            model_name='tracking_origin',
            constraint=models.UniqueConstraint(condition=models.Q(('user', None)), fields=('address', 'endpoint', 'auth', 'details'), name='zut_tracking_origin_uniq_without_user'),
        ),
        migrations.AlterIndexTogether(
            name='tracking_history',
            index_together={('entity_type', 'entity_id')},
        ),
    ]
